﻿var isLocked = false;
var userHoldingBall = "";
var x = 300;
var y = 300;
function pluginInit(hash) {
	trace("---SharedBall Plugin Initialized---");
}
function pluginRequest(hash) {
	var caller = hash.get("ExecutingUserName");
	var method = hash.get("Method");
	if (method == "GetState") {
		//
		broadcastState(false, caller);
	} else if (method == "RequestControl") {
		requestControl(caller);
	} else if (method == "ReleaseControl") {
		releaseControl(caller);
	} else if (method == "UpdatePosition") {
		updatePosition(hash);
	}
}
function updatePosition(hash) {
	x = Number(hash.get("x"));
	y = Number(hash.get("y"));
	broadcastState(true);
}
function requestControl(user) {
	if (!isLocked) {
		isLocked = true;
		userHoldingBall = user;
		broadcastState(true);
	}
}
function releaseControl(user) {
	if (isLocked && user == userHoldingBall) {
		isLocked = false;
		userHoldingBall = "";
		broadcastState(true);
	}
}
function broadcastState(toEveryone, user) {
	var variables = new Object();
	variables.isLocked = isLocked;
	variables.userHoldingBall = userHoldingBall;
	variables.x = x;
	variables.y = y;
	if (toEveryone) {
		server.sendMessage("public", "State", variables);
	} else {
		server.sendMessage("private", [user], "State", variables);
	}
}
function pluginUserEnter(user) {
}
function pluginUserExit(user) {
	if (isLocked && user == userHoldingBall) {
		releaseControl(user);
	}
}